import _extends from "@babel/runtime/helpers/esm/extends";
import PropTypes from 'prop-types';
import cx from 'classnames';
import PolymorphicElement from '@s-ui/react-primitive-polymorphic-element';
import Injector from '@s-ui/react-primitive-injector';
import { ALIGN_ITEMS, ALIGN_CONTENT, BASE_CLASS, JUSTIFY_CONTENT, GUTTER_VALUES, CELL_NUMBERS, BREAKPOINTS } from './settings.js';
import LayoutGridItem from './gridItem/index.js';
import { getGutterClassNames, transition } from './helpers.js';
import { jsx as _jsx } from "react/jsx-runtime";

function LayoutGrid(_ref) {
  var alignContent = _ref.alignContent,
      alignItems = _ref.alignItems,
      _ref$as = _ref.as,
      as = _ref$as === void 0 ? 'div' : _ref$as,
      children = _ref.children,
      justifyContent = _ref.justifyContent,
      gutter = _ref.gutter,
      className = _ref.className,
      colSpan = _ref.colSpan,
      l = _ref.l,
      lOffset = _ref.lOffset,
      m = _ref.m,
      mOffset = _ref.mOffset,
      s = _ref.s,
      sOffset = _ref.sOffset,
      xl = _ref.xl,
      xlOffset = _ref.xlOffset,
      xs = _ref.xs,
      xsOffset = _ref.xsOffset,
      xxl = _ref.xxl,
      xxlOffset = _ref.xxlOffset,
      xxs = _ref.xxs,
      xxsOffset = _ref.xxsOffset;
  var classNames = cx("" + BASE_CLASS, Object.values(ALIGN_CONTENT).includes(alignContent) && BASE_CLASS + "--ac-" + alignContent, Object.values(ALIGN_ITEMS).includes(alignItems) && BASE_CLASS + "--ai-" + alignItems, Object.values(JUSTIFY_CONTENT).includes(justifyContent) && BASE_CLASS + "--jc-" + justifyContent, getGutterClassNames(gutter), className);
  return /*#__PURE__*/_jsx(PolymorphicElement, {
    as: as,
    className: classNames,
    children: /*#__PURE__*/_jsx(Injector, {
      colSpan: colSpan,
      l: l,
      lOffset: lOffset,
      m: m,
      mOffset: mOffset,
      s: s,
      sOffset: sOffset,
      xl: xl,
      xlOffset: xlOffset,
      xs: xs,
      xsOffset: xsOffset,
      xxl: xxl,
      xxlOffset: xxlOffset,
      xxs: xxs,
      xxsOffset: xxsOffset,
      children: children
    })
  });
}

LayoutGrid.displayName = 'LayoutGrid';

var DeprecatedLayoutGrid = function DeprecatedLayoutGrid(props) {
  return /*#__PURE__*/_jsx(LayoutGrid, _extends({}, transition(props)));
};

export default LayoutGrid;
export { DeprecatedLayoutGrid, LayoutGridItem, ALIGN_CONTENT as LayoutGridAlignContent, ALIGN_ITEMS as LayoutGridAlignItems, JUSTIFY_CONTENT as LayoutGridJustifyContent, GUTTER_VALUES as LayoutGridGutterValues, CELL_NUMBERS as LayoutGridCellNumbers, BREAKPOINTS as LayoutGridBreakpoints };